/* Need to compile with -pthread */
#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

typedef struct argdata
{
  int i;
  int return_val;
} arg_data;

void *TaskCode(void *argument)
{
   int tid;
   arg_data *p;
 
   p = (arg_data *) argument;
   tid = (*p).i;
   printf("Hello World! It's me, thread %d!\n", tid);
   p->return_val = tid;
   
   return NULL;
}
 
int main ()
{
   pthread_t thread1,thread2;
   arg_data arg1, arg2; 

   /* create two threads */
   arg1.i = 1;
   arg2.i = 2;
   pthread_create(&thread1, NULL, TaskCode, (void *) &arg1);
   pthread_create(&thread2, NULL, TaskCode, (void *) &arg2);
 
   /* wait for all threads to complete */
   pthread_join(thread1, NULL);
   pthread_join(thread2, NULL);
 
   printf("Done, values in return: %d %d\n", arg1.return_val,
				 arg2.return_val);
   return 0;
}
